#ifndef __TVGUIDE_TVGUIDEOSD_H
#define __TVGUIDE_TVGUIDEOSD_H

#include "timemanager.h"
#include "gridelement.h"
#include "channelepg.h"
#include "statusheader.h"
#include "detailview.h"
#include "timeline.h"
#include "channelgroups.h"
#include "footer.h"
#include "recmenuview.h"
#include "channeljump.h"

// --- cTvGuideOsd -------------------------------------------------------------

class cTvGuideOsd : public cOsdObject {
private:
  cList<cChannelEpg> channels;
  cGridElement *activeGrid;
  cStatusHeader *statusHeader;
  cDetailView *detailView;
  cTimeLine *timeLine;
  cChannelGroups *channelGroups;
  cFooter *footer;
  cRecMenuView *recMenuView;
  cChannelJump *channelJumper;
  int GetLastValidChannel(void);
  bool detailViewActive;
  void DrawOsd(void);
  void CreateChannels(const cChannel *channelStart, int activeChannel = 0, bool init = false);
  void DrawGridsChannelJump(int offset = 0);
  void DrawGridsTimeJump(bool last = false);
  void KeyRed(void);
  void Key1(int Key);
  eOSState KeyBlue(bool *alreadyUnlocked);
  eOSState KeyOk(bool *alreadyUnlocked);
  void NumericKey(eKeys key);
  void TimeJump(eKeys key);
  void ChannelJump(int num);
  void CheckTimeout(void);
  void SetActiveGrid(cGridElement *newActive);
  void ChannelStep(int channelDirection);
  void TimeStep(int timeDirection = eBack);
  void Scroll(int scrollMode = eBack);
  const cChannel *GetChannelNumJump(int &activeChannel, int seekMode = eBack);
  const cChannel *GetChannelGroupJump(int seekMode = eBack);
  eOSState ChannelSwitch(bool *alreadyUnlocked);
  void DetailedEPG(void);
  void SetTimers(void);
  void Dump(void);
public:
  cTvGuideOsd(void);
  virtual ~cTvGuideOsd(void);
  virtual void Show(void);
  virtual eOSState ProcessKey(eKeys Key);
};

#endif //__TVGUIDE_TVGUIDEOSD_H
